# MadHack's Tewlz 2.5
# Generic set of tools
# By Mike Markley aka MadHack <madhack@pobox.com>
# Originally written for use on HighHopes
# Thanks to bLeaCH for the ideas for the public commands, and |Hatter|,
# kaya, CorpClegg, Spamby, Loadzebol, and many other ppl on #pinkfloyd
# for help with testing... this thing needed lots of it :)
# Thanks to my g/f alliekat because it's kinda nice to have the support
# of someone rooted in the real world when you do lots of stuff like
# this :)

### Stuff to set ###
# Use this to set the timezone for .time (in relation to GMT)
set TMZ -6

# Set users away after a specific amount of time? (0 to disable)
set idleaway 1

# Delay in minutes to wait before setting users .away
set idletime 5

# Allow public commands? (0 to disable)
set pub_allow 1

# Set this to the name of the person(s) (usually owner) who should be
# notified of any activities involving channels, handled by ChanServ
set ChanNotify "MadHack"

##################### Do not edit beyond this point #####################

# This initializes a few timers
if {![string match "*check_idle*" [utimers]]} { utimer 60 check_idle }
if {![string match "*anti_idle*" [timers]]} { timer 20 anti_idle }

# All bindings here
set flag1 i
bind join i *!*@*  auto_op
bind join n *!*@* op_owner
bind dcc m +chan add_channel
bind dcc m -chan del_channel
bind dcc m chchan chan_settings
bind dcc m tewlz load_tewlz
bind dcc - time dcc_time
bind pub - !time pub_time
bind msg - time msg_time
bind dcc - date dcc_date
bind pub - !date pub_date
bind msg - date msg_date
bind chon - * dcc_info
bind filt - "\001ACTION *\001" filter_action
bind part p * part_laston
bind sign p * quit_laston
bind dcc m announce dcc_announce
bind msg o invite* msg_invite
bind dcc o gmt dcc_gmt
bind dcc m isolate do_isolate
bind dcc m merge do_merge
if {$pub_allow} {
  bind pub o @help pub_pubhelp
  bind pub m @chattr pub_chattr
  bind pub o @whois pub_whois
  bind pub m @adduser pub_adduser
  bind pub m @jump pub_jump
  bind pub o @+ban pub_addban
  bind pub o @-ban pub_delban
  bind pub o @bans pub_banlist
} {
  catch {unbind pub o @help pub_pubhelp}
  catch {unbind pub m @chattr pub_chattr}
  catch {unbind pub o @whois pub_whois}
  catch {unbind pub m @adduser pub_adduser}
  catch {unbind pub m @jump pub_jump}
  catch {unbind pub o @+ban pub_addban}
  catch {unbind pub o @-ban pub_delban}
  catch {unbind pub o @bans pub_banlist}
}

set TewlzVer "2.5"

# Funny little thing
bind pubm p *marco* polo
proc polo {nick uhost hand chan text} {
  puthelp "PRIVMSG $chan :polo"
}

# Little putnot proc in case toolkit.tcl isn't loaded...
proc putnot {nick msg} {
  puthelp "NOTICE $nick :$msg"
}

# These two procs pad text with spaces either on the left or the right
proc padright {text spaces} {
  set spaces [expr $spaces - [string length $text]]
  for {set spc ""} {$spaces != 0} { set spaces [expr $spaces - 1] } {
    append spc " "
  }
  set text "$text$spc"
  return $text
}
proc padleft {text spaces} {
  set spaces [expr $spaces - [string length $text]]
  for {set spc ""} {$spaces != 0} { set spaces [expr $spaces - 1] } {
    append spc " "
  }
  set text "$spc$text"
  return $text
}

# Selective auto-op
# Copied out of the TRICKS file
proc auto_op {nick uhost hand chan} {
  pushmode $chan +o $nick
  flushmode $chan
  putlog "Giving op to $nick!$uhost ($hand) on $chan"
}

# Auto-op of Owner
proc op_owner {nick uhost hand chan} {
   pushmode $chan +o $nick
   flushmode $chan
   putlog "Giving op to Owner $nick!$uhost ($hand) on $chan"
}

# Add channel support with somewhat standard options
# usage: .+chan <#channel>
# Masters only
proc add_channel {hand idx chan} {
  global ChanNotify
  if {$chan == ""} {
    putdcc $idx "Usage: +chan <channel>"
    return 0
  }
  if {[string match "*[string tolower $chan]*" [string tolower [channels]]]} {
    putdcc $idx "I'm already on $chan!"
    return 0
  }
  channel add $chan
  channel set $chan -clearbans +enforcebans +dynamicbans +userbans -autoop -bitch +greet -protectops -statuslog +stopnethack -revenge
  foreach q $ChanNotify {
    sendnote ChanServ $q "$hand added $chan on [date] at [time]."
  }
  putdcc $idx "Added $chan"
  return 1
}

# Remove channel support
# usage: .-chan <#channel>
# Masters only
proc del_channel {hand idx chan} {
  global ChanNotify
  if {$chan == ""} {
    putdcc $idx "Usage: -chan <channel>"
    return 0
  }
  if {![string match "*[string tolower $chan]*" [string tolower [channels]]]} {
    putdcc $idx "Error: $chan is not a listed channel."
    return 0
  }
 channel remove $chan
  foreach q $ChanNotify {
    sendnote ChanServ $q "$hand deleted $chan on [date] at [time]."
  }
  putdcc $idx "Removed $chan"
  return 1
}

# I borrowed the idea for this one from services.tcl... it seemed like
# the perfect complement to the +chan and -chan (which I recently
# discovered services.tcl had a similar command for :)
proc chan_settings {hand idx arg} {
  global ChanNotify
  if {$arg == ""} {
    putdcc $idx "Usage: chchan <channel> <settings>"
    return 0
  }
  set chan [lindex $arg 0]
  if {![string match "*[string tolower $chan]*" [string tolower [channels]]]} {
    putdcc $idx "Error: $chan is not a listed channel."
    return 0
  }
  set mode [lrange $arg 1 end]
  channel set $chan $mode
  foreach q $ChanNotify {
    sendnote ChanServ $q "$hand changed $chan settings: $mode on [date] at [time]."
  }
  putdcc $idx "Set $chan to: $mode"
  return 1
}

# Reload MadHack's Tewlz
# usage: .tewlz
# Masters only
proc load_tewlz {hand idx arg} {
  putlog "Reload requested by $hand"
  source scripts/madhack.tcl
}

bind msg - tewlzcheck show_tewlz
proc show_tewlz {nick uhost hand chan args} {
  global TewlzVer
  puthelp "PRIVMSG $nick :  "
  puthelp "PRIVMSG $nick :MadHack's Tewlz version $TewlzVer"
  puthelp "PRIVMSG $nick :  "
}

# Display system time... please make sure TMZ is set :).
proc dcc_time {hand idx args} {
  global TMZ
  putdcc $idx "Current time is [time] GMT$TMZ"
  return 1
}
proc pub_time {nick uhost hand chan args} {
  global TMZ
  puthelp "PRIVMSG $chan :It is now [time] GMT$TMZ"
  return 1
}
proc msg_time {nick uhost hand args} {
  global TMZ
  puthelp "PRIVMSG $nick :It is now [time] GMT$TMZ"
  return 1
}

# Shows time in GMT
proc dcc_gmt {hand idx args} {
  putdcc $idx "[clock format [unixtime] -format "%B %d, %Y%n%H:%M GMT" -gmt 1]"
  return 1
}

# Display system date
proc dcc_date {hand idx args} {
  putdcc $idx "Current date is [date]"
  return 1
}
proc pub_date {nick uhost hand chan args} {
  puthelp "PRIVMSG $chan :It is now [date]."
  return 1
}
proc msg_date {nick uhost hand args} {
  puthelp "PRIVMSG $nick :It is now [date]."
  return 1
}

proc dcc_info {hand idx} {
  set userinfo [getinfo $hand]
  if {$userinfo != ""} {
    dccbroadcast "\[$hand\] $userinfo"
  }
}

# Idle check for auto-away on partyline
proc check_idle {} {
  global idleaway idletime
  if {!($idleaway)} { utimer 60 check_idle ; return 0 }
  foreach q [dcclist] {
    set idx [lindex $q 0]
    set nick [lindex $q 1]
    set host [lindex $q 2]
    set type [lindex $q 3]
    set hand [idx2hand $idx] 
     if {([getdccidle $idx] > [expr $idletime * 60]) && 
        ([getdccaway $idx] == "") &&
        ([matchattr $hand "o"])} {
          setdccaway $idx "Automatically set away after $idletime minutes idle"
        }
      }
  utimer 60 check_idle
}

# Filters ACTION's on the partyline and converts to .me
proc filter_action {idx text} {
  set text [string trimleft $text "\001ACTION "]
  set text [string trimright $text "\001"]
  dccsimul $idx ".me $text"
  return 1
}

# Quiet anti-idle
proc anti_idle {} {
  putserv "PRIVMSG"
  timer 20 anti_idle
}

# Public commands help system
proc pub_pubhelp {nick uhost hand chan args} {
  set helpcom [string tolower [lindex $args 0]]
  if {[matchattr $hand "m"]} { set flag "m" } { set flag "o" }
  if {$helpcom == ""} {
    dumpfile $nick pub.help.o
    if {$flag == "m"} { dumpfile $nick pub.help.m }
    dumpfile $nick pub.help
    return 1
  }
  if {[file exists text/pub.help.$helpcom.o]} {
    dumpfile $nick pub.help.$helpcom.o
    if {![file exists text/pub.help.$helpcom.m]} { return 1 }
  }
  if {$flag == "m" && [file exists text/pub.help.$helpcom.m]} {
    dumpfile $nick pub.help.$helpcom.m
    return 1
  }
  putnot $nick "No help available on that."
  return 0
}

# Public chattr command
proc pub_chattr {nick uhost hand chan arg} {
  set modhand [lindex $arg 0]
  if {$modhand == ""} {
    putnot $nick "Usage: chattr <handle> [changes]"
    return 0
  }
  if {![validuser $modhand]} {
    putnot $nick "No such user!"
    return 0
  }
  set attr [lrange $arg 1 end]
  if {![matchattr $hand "n"]} { regsub -all "n" $attr "" attr ; regsub -all "m" $attr "" attr }
  chattr $modhand $attr
  putnot $nick "Flags for $modhand are now +[chattr $modhand]"
  return 1
}

# Public whois command
proc pub_whois {nick uhost hand chan args} {
  global notefile
  set addies ""
  set comment ""
  set email ""
  set info ""
  set gethand [lindex $args 0]
  if {$gethand == ""} {
    putnot $nick "Usage: whois <handle>"
    return 0
  }
  set fd [open $notefile r]
  set notes 0
  while {![eof $fd]} {
    gets $fd curlin
    if {[string tolower $gethand] == [string tolower [lindex $curlin 0]]} { set notes [expr $notes + 1] }
  }
  close $fd
  set curdate "[lindex [date] 0] [lindex [date] 1]"
  if {[validuser $gethand] == 0} {
    putnot $nick "Can't find anytone matching that."
    return 0
  }
  if {[passwdok $gethand ""]} { set pass "no" } { set pass "yes" }
  set flags [chattr $gethand]
  set laston "[lindex [ctime [getlaston $gethand]] 2] [lindex [ctime [getlaston $gethand]] 1]"
  if {$laston == $curdate} {
    set laston "[string range [lindex [ctime [getlaston $gethand]] 3] 0 4]"
  }
  set addies [gethosts $gethand]
  set comment [getcomment $gethand]
  set email [getemail $gethand]
  set info [getinfo $gethand]
  putnot $nick "HANDLE    PASS FLAGS                    NOTES LAST"
  putnot $nick "[padright $gethand 9] [padright $pass 4] [padright $flags 24] [padleft $notes 5] $laston"
  foreach addy $addies {
    putnot $nick "          $addy"
  }
  if {$comment != "" && [matchattr $hand "m"]} {
    putnot $nick "          COMMENT: $comment"
  }
  if {$email != ""} {putnot $nick "          EMAIL: $email"}
  if {$info != ""} {putnot $nick "          INFO: $info"}
  return 1
}

# Public adduser command, works same as DCC version (adds new user if
# not in bot, adds that hostmask to that user if already there, etc.)
proc pub_adduser {nick uhost hand chan args} {
  set newuser [lindex $args 0]
  if {$newuser == ""} {
    putnot $nick "Usage: adduser <nick>"
    return 0
  }
  set mask [maskhost [getchanhost $newuser $chan]]
  if {![onchan $newuser $chan]} {
    putnot $nick "$newuser is not on $chan."
    return 0
  }
  if {[nick2hand $newuser $chan] != "*"} {
    putnot $nick "$newuser is already known as [nick2hand $newuser $chan]."
    return 0
  }
  if {[validuser $newuser]} {
    set hostexists 0
    if {[gethosts $newuser] != "none"} {
    foreach host [gethosts $newuser] {
      if {[string match [string tolower [string trim $host]] [string tolower [string trim $mask]]] || [string match [string tolower [string trim $mask]] [string tolower [string trim $host]]]} { set hostexists 1 }
    }
    }
    if {!($hostexists)} {
      addhost $newuser $mask
      putnot $nick "Added hostmask $mask to $newuser."
    }
    return 1
  }
  adduser $newuser $mask
  putnot $nick "Added \[$newuser\]$mask with no password."
  return 1
}

# Public jump command, self-explanatory
proc pub_jump {nick uhost hand chan args} {
  set server [lindex $args 0]
  set port [lindex $args 1]
  set password [lindex $args 2]
  putnot $nick "Attempting to jump servers..."
  jump $server $port $password
  return 1
}

# Adds ban to banlist, works same as DCC one and at least attempts
# to filter out bans of owners
proc pub_addban {nick uhost hand chan args} {
  global botnick
  set banmask [lindex $arg 0]
  if {$banmask == ""} {
    putnot $nick "Usage: +ban <hostmask> [reason]"
    return 0
  }
  set comment [lrange $arg 1 end]
  if {![matchattr $hand "n"]} {
  foreach owner [userlist n] {
    foreach mask [gethosts $owner] {
    if {[string match [string tolower [string trim $banmask]] [string tolower [string trim $mask]]] || [string match [string tolower [string trim $mask]] [string tolower [string trim $banmask]]]} {
      pushmode $chan -o $nick
      putnot $nick "$banmask would ban a +n user on this bot."
      putnot $nick "The owner will be informed of this and your master and op status have been stripped until further notice."
      chattr $hand -[chattr $hand]
      chattr $hand +d
      sendnote $botnick [finduser $banmask] "$nick!$uhost ($hand) attempted to ban you. His/her master and op status have been stripped."
      return 0
    }
    }
  }
  }
  newban $banmask $hand $comment
  putnot $nick "New ban: $banmask (request)"
  return 1
}
# Deletes bans from the banlist
proc pub_delban {nick uhost hand chan args} {
  set banmask [lindex $args 0]
  if {$banmask == ""} {
    putnot "No such ban."
    return 0
  }
  if {[isban $banmask]} {
    killban $banmask
    putnot $nick "Removed ban: $banmask"
    return 1
  } {
    if {[isban $banmask $chan]} {
      killchanban $chan $banmask
      putnot $nick "Removed ban: $banmask on $chan"
      return 1
    } { putnot $nick "No such ban." ; return 0 }
  }
}
# Gives a list of current bans thru notice
proc pub_banlist {nick uhost hand chan args} {
  set bannum 1
  foreach ban [banlist] {
    set banmask [lindex $ban 0]
    set timeset [expr [unixtime] - [lindex $ban 3]]
    set days [expr $timeset / 86400]
    set creator [lindex $ban 5]
    set comment [lindex $ban 1]
    if {[lindex $ban 2] != 0} {
      set expire [string range [lindex [ctime [lindex $ban 2] 3] 0 4]
    } {
      set expire "(perm)"
    }
    putnot $nick "      \[[padleft $bannum 3]\] $banmask $expire"
    putnot $nick "      $creator: $comment"
    putnot $nick "      Created $days days ago"
    set bannum [expr $bannum + 1]
  }
  return 1
}

# These change the last on time for a user when he/she quits or parts..
# Makes the last on time more useful, IMO
proc part_laston {nick uhost hand chan} {
  setlaston $hand [unixtime]
}
proc quit_laston {nick uhost hand chan reason} {
  setlaston $hand [unixtime]
}

# Makes for simple announcements across a botnet
proc dcc_announce {hand idx arg} {
  if {$arg == ""} {
    putdcc $idx "Usage: announce <message>"
    return 0
  }
  dccbroadcast "$hand: $arg"
  return 1
}

proc do_isolate {hand idx arg} {
  global isolate
  if {$isolate} { return 0 }
  putdcc $idx "Isolating the partyline."
  set isolate 1
  return 1
}
proc do_merge {hand idx arg} {
  global isolate
  if {!($isolate)} { return 0 }
  putdcc $idx "Merging the partyline."
  set isolate 0
  return 1
}

# Making note of load
putlog "MadHack's Tewlz $TewlzVer by MadHack <madhack@pobox.com>"

